import {getServerTree} from './lib/ServerTree.js'

/** @param {NS} ns */
export async function main(ns) {
	const serverTree = getServerTree(ns)
	ns.write("dump/map.txt", serverTree.toJson(), 'w')
	if (ns.args[0] != "noout") {
		ns.tprintf("")
		serverTree.printTable()
	}
}